local platforms = {7,6,10,9,5,4,3,8,1}
// 7 5 6
// 4 1 3
// 108 9

freeslot("sfx_dx0001") -- It's-a Wario... Deluuuuxe!
WARE_AddMinigame("deluxe", {
	// Minigame rush kind of boss
	// You get a jumbled up prompt and speed rises every 4 minigames with no warning
	// Unused because holy shit the song was heavy (1.84mb)
	// also I didn't want to sanitize minigames
	// Will never be picked as boss minigame, but you can force it
	// You just get no song (game will complain about missing music)
	// or sound prompt to accompany it
	// https://twitter.com/Rapidgame7/status/1254264302011404290
	DOESNOTCOUNT = true,
	incomplete = true,
	boss = true,
	prompt = "Oh nao...",
	
	condition = function() return false end,
	
	music = "DELUXE",
	
	timelimit = TICRATE*4+17,
	
	fStart = function()
		S_StartSound(nil, sfx_dx0001)
		WARE.deluxe = true
		WARE.speed = 1
	end,
})

local enemies = {
	MT_JETTGUNNER,
	MT_JETTBOMBER,
}
WARE_AddMinigame("onslaught", {
	boss = true,
	prompt = "Nao seja atingido!",
	
	music = "WAMOSL",
	skin = "knuckles",
	
	timelimit = 40*TICRATE+15,
	
	fStart = function()
		local mem = WARE.mem
	end,
	fThink = function()
		local mem = WARE.mem
		local plys = WARE_GetPlaying()
		WARE_ForEachPlayer(function(p,ix)
			WARE_PlayerSetStatus(p, true, false)
			if p.powers[pw_flashing] then WARE_PlayerSetStatus(p, false, true) end
		end)
		
		if (WARE.time % 16) == 0 then
			local m = P_SpawnMobj(0,0,128*FRACUNIT,randomChoose(enemies))
			m.angle = P_RandomRange(0,359)*ANG1
			launchAbsolute(m, P_RandomRange(0,359)*ANG1, 0, 35*FRACUNIT)
		end
	end,
	hMobjMoveCollide = function(m,n)
		if (m.flags & MF_ENEMY) and (n.flags & MF_ENEMY) then return false end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & (MF_ENEMY|MF_MISSILE)) > 0 then P_RemoveMobj(m) end
		end
		WARE_FixOrigin()
	end
})

WARE_AddMinigame("amy", {
	/*
		Minigame is played by two teams: Blue Sonics and Pink Amys
		Sonic players do not have the luxury of thok here
		Collision with Amy as Sonic results in instant death
		
		Objective:
		As Amy, empty the field from all Sonic players
		As Sonic, avoid Amy at all costs
		
		Sonic players win if they are still alive
		Amy players win if there are no Sonics in the field
	*/
	boss = true,
	prompt = "multiprompt...",
	
	condition = function() return WARE.playercount > 1 end,
	spawnpoint = MAPPOS_AuxArena,
	
	music = "WAMAMY",
	--skin = "knuckles",
	
	timelimit = 50*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		// For every 4 players, there has to be 1 amy
		// 1p: 1a 0s
		// 2p: 1a 1s
		// 3p: 1a 2s
		// 4p: 1a 3s
		// 5p: 2a 3s
		// 6p: 2a 4s
		WARE_ForEachPlayer(function(p)
			p.waremem.prompt = "Fuja da Amy!"
			R_SetPlayerSkin(p, "sonic")
			WARE_ForcePlayerSkin(p, "sonic", SKINCOLOR_BLUE)
			p.charability = CA2_NONE
			P_TeleportMove(p.mo, -960*FRACUNIT, -1600*FRACUNIT, 0)
			p.mo.angle = ANGLE_315
		end)
		local ac = (c+3)/4
		local plys = WARE_GetPlaying()
		for ix = 1,ac do
			local p = table.remove(plys,P_RandomRange(1,#plys))
			p.waremem.hunter = true
			p.waremem.prompt = "Pegue todos os Sonics!"
			R_SetPlayerSkin(p, "amy")
			WARE_ForcePlayerSkin(p, "amy", SKINCOLOR_ROSY)
			P_TeleportMove(p.mo, 960*FRACUNIT, -3520*FRACUNIT, 0)
			p.mo.angle = ANGLE_135
		end
		
		// -960 -1600
		// 960 -3520
	end,
	fThink = function()
		local mem = WARE.mem
		local sonicAlive = false
		WARE_ForEachPlayer(function(p)
			WARE_PlayerSetStatus(p, (p.mo.skin == "sonic"), false)
			if p.mo.skin == "sonic" and p.playerstate == PST_LIVE then sonicAlive = true end
		end)
		
		if not sonicAlive then
			WARE_ForEachPlayer(function(p)
				if p.mo.skin == "amy" then WARE_PlayerSetStatus(p, true, true) end
			end)
		end
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		if m.type == n.type and m.type == MT_PLAYER then
			if m.skin == "amy" and n.skin == "sonic" then
				// Tagged!
				P_DamageMobj(n, m, m, 666)
				WARE_PlayerLose(n.player, true)
			end
		end
	end end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & (MF_ENEMY|MF_MISSILE)) > 0 then P_RemoveMobj(m) end
		end
		WARE_FixOrigin()
	end
})

local function chunprio(p)
	if p == displaypayer then return 3 // Focused player - Must be on top at all times
	elseif p.waremem.hunter then return 2 // A hunter - Important lmao
	else return 1 end // probably some dumb who cares
end
WARE_AddMinigame("chungus", {
	/*
		Two teams: Chungus and Seekers (Amy)
	*/
	boss = true,
	prompt = "multiprompt...",
	
	condition = function() return WARE.playercount > 1 end,
	spawnpoint = MAPPOS_Maze_TopLeft,
	
	music = "WAMSLE",
	musicloop = true,
	--skin = "knuckles",
	
	timelimit = 75*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		local ac = (c+3)/4
		local plys = shuffleTable(WARE_GetPlaying())
		local pp = MAPPOS_Maze_TopLeft
		local pp2 = deepcopy(MAPPOS_Maze_TopLeft)
		pp2.x = $ + 1536*3
		pp2.y = $ - 1536*3
		for i = 1,#plys do
			local p = plys[i]
			if i <= ac then
			//if false then
				p.waremem.hunter = true
				p.waremem.prompt = {"Pegue todas as Amys!","Nao deixe elas vencerem!"}
				WARE_ForcePlayerSkin(p, "knuckles", SKINCOLOR_BLACK)
				P_TeleportMove(p.mo, pp.x*FRACUNIT, pp.y*FRACUNIT, (pp.z+64)*FRACUNIT)
				p.mo.angle = ANGLE_315
			else
				p.waremem.hunter = false
				p.waremem.prompt = {"Destrua todos os monitores!","Sobreviva!"}
				WARE_ForcePlayerSkin(p, "amy")
				P_TeleportMove(p.mo, pp2.x*FRACUNIT, pp2.y*FRACUNIT, (pp2.z+64)*FRACUNIT)
				p.mo.angle = ANGLE_45
			end
		end
		mem.spots = {}
		for x = 0,3 do for y = 0,3 do
			local xp = pp.x + 1536*x
			local yp = pp.y - 1536*y
			--local mon = P_SpawnMobj(xp*FRACUNIT, yp*FRACUNIT, 0, MT_SCORE1K_BOX)
			--mon.flags2 = $|MF2_DONTRESPAWN
			mem.spots[#mem.spots+1] = {xp*FRACUNIT,yp*FRACUNIT,used=false}
		end end
		//mem.montarget = 12
		mem.montarget = 10 + WARE.playercount-2
		mem.mons = {}
		mem.busted = 0
	end,
	fThink = function()
		local mem = WARE.mem
		local amyAlive = false
		local chungi = 0
		WARE_ForEachPlayer(function(p)
			p.normalspeed = $/2
			local isAmy = p.mo.skin == "amy"
			--WARE_PlayerSetStatus(p, isAmy, false)
			if isAmy and p.playerstate == PST_LIVE then amyAlive = true end
			if not isAmy then
				chungi = $+1
				p.normalspeed = ($/2)+FixedMul(FRACUNIT*8,WARE.spdcoef) //scale stupid, also extra spd to outspd amy
				p.accelstart = $/3
				--p.acceleration = $
				p.charability = 0
				p.charability2 = 0
				p.pflags = $|PF_NOJUMPDAMAGE
				local m = p.mo
				m.scale = FRACUNIT*2
				m.sprite = SPR_CHUN
				m.frame = 0
				
				local spd = R_PointToDist2(0, 0, m.momx, m.momy)
				--print(spd/FRACUNIT)
				--print(p.normalspeed/FRACUNIT)
				if spd > FixedMul(p.normalspeed, FRACUNIT*4/3) then
					--print("Locked")
					if not p.waremem.anglelock then
						p.waremem.anglelock = true
						p.waremem.angle = m.angle
					end
					m.angle = p.waremem.angle
				else
					p.waremem.anglelock = false
				end
			end
		end)
		
		local mons = mem.mons
		--print("1got "..#mons)
		// Remove entries that don't exist
		for i = #mons,1,-1 do
			if not (mons[i] and mons[i].valid and mons[i].health > 0) then table.remove(mons,i) end
		end
		--print("2got "..#mons)
		
		// Spawn monitors if some are missing
		local expected = max(chungi+1, 2)
		local iter = 0
		while #mons < expected do
			iter = $+1
			if iter > 150 then error("panic") end
			local r = P_RandomRange(1,#mem.spots)
			if mem.spots[r].used then continue end // Try again
			local s = mem.spots[r]
			s.used = true
			local mon = P_SpawnMobj(s[1], s[2], 0, MT_SCORE1K_BOX)
			--print("More!")
			mon.spot = r
			mons[#mons+1] = mon
		end
		--print("3of "..#mons.." "..expected)
		
		WARE_ForEachPlayer(function(p)
			--WARE_PlayerSetStatus(p, (not p.waremem.hunter)) -- No default win status, stupid
			if not amyAlive then
				WARE_PlayerSetStatus(p, (p.waremem.hunter or false), true)
			elseif mem.busted >= mem.montarget then
				if not p.waremem.wonlock and p.mo.skin == "knuckles" then
					S_StartSound(p.mo, sfx_fooey)
				end
				WARE_PlayerSetStatus(p, (p.mo.skin == "amy"), true)
			end
		end)
		
	end,
	fHud = function(v,p,c)
		drawStringMkII(v,160*FRACUNIT,35*FRACUNIT,
			WARE.mem.busted.."/"..WARE.mem.montarget,FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=SKINCOLOR_RED,style=FS_FIXED}
		)
		
		local stx,sty = 160*FRACUNIT,(200-50)*FRACUNIT
		local stflags = V_SNAPTOBOTTOM
		if p.waremem.hunter then
			if p.waremem.anglelock then
				drawStringMkII(v,stx,sty,
					"(angulo travado)",FONT_CONSOLE2,
					stflags,
					{valign="center",align="center",color=SKINCOLOR_RED,style=FS_FIXED}
				)
			end
		end
		
		local pixel = v.cachePatch("APIXEL")
		local pixel2 = v.cachePatch("A2PIXEL")
		local pixel2dark = v.cachePatch("A2PIXEL2")
		local pp = MAPPOS_Maze_TopLeft
		
		local mmx,mmy = 20*FRACUNIT, 60*FRACUNIT
		local mms = 32*FRACUNIT,32*FRACUNIT
		local mmflags = V_SNAPTOLEFT|V_SNAPTOTOP
		local mmdiv = 128
		local xoff = pp.x*FRACUNIT
		local yoff = pp.y*FRACUNIT
		
		// BG
		v.drawScaled(mmx, mmy, ((pp.x+1536*3)*FRACUNIT-xoff)/mmdiv, pixel, mmflags, v.getColormap(-1, SKINCOLOR_BLACK))
		
		// Path
		local sep = (1536*3)/24
		for x = 0,1536*3,sep do
		for y = 0,1536*3,sep do
			local here = R_PointInSubsectorOrNil((pp.x+x)*FRACUNIT,(pp.y-y)*FRACUNIT)
			if here and here.sector.floorheight == 0 then
				local tx = (x*FRACUNIT)/mmdiv
				local ty = (y*FRACUNIT)/mmdiv
				v.drawScaled(mmx+tx, mmy+ty, FRACUNIT*4/3, pixel2dark, mmflags, v.getColormap(-1, SKINCOLOR_CARBON))
			end
		end
		end
		
		// Monitors
		local mons = WARE.mem.mons
		for i = 1,#mons do
			local m = mons[i]
			if m and m.valid and m.health > 0 then
				local tx = (m.x-xoff)/mmdiv
				local ty = (m.y-yoff)/mmdiv
				v.drawScaled(mmx+tx, mmy-ty, FRACUNIT/2, pixel2, mmflags, v.getColormap(-1, SKINCOLOR_PURPLE))
			end
		end
		
		// Players
		local plys = WARE_GetPlaying()
		table.sort(plys, function(a,b) return chunprio(a) > chunprio(b) end)
		for i = 1,#plys do
			local o = plys[i]
			if o.playerstate ~= PST_LIVE then continue end // Not alive
			local m = o.mo
			local tx = (m.x-xoff)/mmdiv
			local ty = (m.y-yoff)/mmdiv
			local col = o.waremem.hunter and SKINCOLOR_RED or SKINCOLOR_WHITE
			if o == p then col = SKINCOLOR_BLUE end
			
			if (o.waremem.hunter // This player is a hunter, always show for everyone
			or
			(not o.waremem.hunter and not consoleplayer.spectator and not consoleplayer.waremem.hunter)
			) then // Not a hunter, show only if computer player is on seeker team
				v.drawScaled(mmx+tx, mmy-ty, FRACUNIT, pixel2, mmflags, v.getColormap(-1, col))
				local cx,cy = cSpd(m.angle, 2*FRACUNIT)
				v.drawScaled(mmx+tx+cx, mmy-ty-cy, FRACUNIT/2, pixel2, mmflags, v.getColormap(-1, col))
			end
		end
	end,
	hMobjMoveCollide = function(m,n) // No Z checks
		if m.type == n.type and m.type == MT_PLAYER and WARE_PlayerInPlay(m.player) and WARE_PlayerInPlay(n.player) then
			if m.skin == "knuckles" and n.skin == "amy" then
				// Tagged!
				S_StartSound(m,sfx_alwigt)
				P_DamageMobj(n, m, m, 666)
				WARE_PlayerLose(n.player, true)
			end
		end
	end,
	hMobjDeath = function(m)
		if m.flags & MF_MONITOR then
			WARE.mem.busted = $+1
			S_StartSound(nil, sfx_q3mnu4)
			--m.fuse = TICRATE
		end
	end,
	hMobjThinker = function(m)
		if m.type == MT_SCORE1K_BOX then
			if m.fux == nil then m.fux = 0 end
			if m.health == 0 then
				if leveltime&1 then m.flags2 = $^^MF2_DONTDRAW end
				m.fux = $+1
			end
			if m.fux > TICRATE-1 then
				WARE.mem.spots[m.spot].used = false // Free up
				P_RemoveMobj(m)
			end
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & (MF_MONITOR)) > 0 then P_RemoveMobj(m) end
		end
	end
})

local ref = WARE_FindGetMinigame("missile")
WARE_AddMinigame("missile_ex", {
	// The same bullshit but faster
	
	DOESNOTCOUNT = true,
	incomplete = true, // Balance issues
	boss = true,
	prompt = "Desvie!",
	
	skin = "metalsonic",
	spawnpoint = MAPPOS_Missile_Ply,
	
	music = "WAMMS2",
	musicloop = true,
	
	timelimit = 25*TICRATE,
	
	fStart = function()
		WARE.mem.boss = true,
		ref.fStart()
	end,
	fThink = ref.fThink,
	hMobjThinker = ref.hMobjThinker,
	hMobjMoveCollide = ref.hMobjMoveCollide,
	hHurtMsg = ref.hHurtMsg,
	fEnd = ref.fEnd,
})

local function handRail(p)
	p.powers[pw_railring] = 1
	p.ringweapons = RW_RAIL
	p.currentweapon = WEP_RAIL
end
WARE_AddMinigame("quickdraw", {
	// WGFIRE
	// WAMSSR
	/* Inspired by TF2Ware beta gameplay
	Players are all frozen and placed in a circle
	Can still aim around, just not move or jump
	All players are given 1 rail
	
	After a random amount of time, "FIRE!" plays
	Shoot a random opponent with a rail to make them lose
	Shooting an opponent makes you immune to all shots afterwards
	After three seconds, survivors are repositioned and minigame starts again
	
	Shooting before the signal jams your weapon and prevents you from shooting this round
	
	If a round goes by and nobody shoots, the minigame ends
	Yes, that means everyone wins, but that means nobody gets the 5 point advantage proper lmao
	If a round results in 1 or fewer survivors (how?), the minigame ends
	*/
	--prompt = "Dodge!",
	boss = true,
	condition = function() return WARE.playercount > 1 end,
	skin = "fang",
	spawnpoint = MAPPOS_Shootout_Center,
	skynum = 13,
	weaponrings = true,
	
	//music = "WAMSSR",
	//musicloop = true,
	notemposhift = true,
	
	timelimit = 99*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.reprep = true
		local c = MAPPOS_Shootout_Center
		for i = 1,15 do
			local tw = P_SpawnMobj(c.x*FRACUNIT, c.y*FRACUNIT, c.z*FRACUNIT,
				i <= 4 and MT_BIGTUMBLEWEED or MT_LITTLETUMBLEWEED
			)
			tw.flags2 = $|MF2_AMBUSH
			launchScatter(tw, 10*FRACUNIT)
		end
		mem.round = 0
	end,
	fThink = function()
		local mem = WARE.mem
		if mem.reprep then
			mem.reprep = false
			local c = MAPPOS_Shootout_Center
			WARE_WarpPlayers(c, {"radial", 736*FRACUNIT})
			WARE_ForEachPlayer(function(p)
				local m = p.mo
				m.angle = R_PointToAngle2(m.x, m.y, c.x*FRACUNIT, c.y*FRACUNIT)
				handRail(p)
				p.waremem.jammed = false
				p.waremem.killer = false
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end)
			WARE_PlayMusic("WAMSSR")
			mem.round = $+1
			mem.fire = false
			mem.countdown = TICRATE*10
			if mem.round > 1 then
				mem.countdown = P_RandomRange(TICRATE*4, TICRATE*11)
			end
		end
		
		WARE_ForEachPlayer(function(p)
			p.pflags = $|PF_FULLSTASIS
			WARE_PlayerWin(p)
			local m = p.mo
			if p.waremem.killer then
				m.color = SKINCOLOR_GOLD
				m.colorized = true
			end
			if p.powers[pw_railring] > 1 then p.powers[pw_railring] = 1 end
			
			/*
			for i = 1,12 do
				local xx,yy,zz = cSpdEx(m.angle, p.aiming, 15*FRACUNIT*i)
				local tk = P_SpawnMobj(m.x+xx,m.y+yy, m.z+zz+m.height/2, MT_THOK)
				tk.frame = A
				tk.fuse = 2
				tk.scale = FRACUNIT/2
			end*/
		end)
		
		mem.countdown = $-1
		if mem.countdown <= 0 then
			if not mem.fire then
				mem.fire = true
				S_StartSound(nil, sfx_wgfire)
				WARE_PlayMusic("SSSHHH")
			end
			WARE_ForEachPlayer(function(p)
				p.weapondelay = p.waremem.jammed and 12 or 0 // lower a bit if jam
			end)
		else
			WARE_ForEachPlayer(function(p)
				p.weapondelay = 15
				if WARE_PlayerCompeting(p) and p.cmd.buttons & BT_ATTACK > 0 then
					if not p.waremem.jammed then
						S_StartSound(nil, sfx_gunjam)
						p.waremem.jammed = true
					end
				end
			end)
		end
		
		if mem.countdown < -5*TICRATE then
			local finish = false
			if WARE.livingcount <= 1 then
				finish = true
				WARE.time = 99*TICRATE
			end
			mem.reprep = true
		end
		mem.l = 9
	end,
	fHud = function(v,p,c)
		local mem = WARE.mem
		local str = "Round "..mem.round
		local col = SKINCOLOR_WHITE
		if mem.fire then str = "Fogo!";col = SKINCOLOR_RED end
		drawStringMkII(v,160*FRACUNIT,35*FRACUNIT,
			str,FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=col,style=FS_FIXED}
		)
		if p.waremem.jammed then
			drawStringMkII(v,160*FRACUNIT,43*FRACUNIT,
				"Arma emperrada!",FONT_CONSOLE2,
				V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_CRIMSON,style=FS_FIXED}
			)
		end
		if p.waremem.killer then
			drawStringMkII(v,160*FRACUNIT,43*FRACUNIT,
				"Acertou um!",FONT_CONSOLE2,
				V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_GOLD,style=FS_FIXED}
			)
		end
	end,
	--hHurtMsg = ref.hHurtMsg,
	hShouldDamage = function(m,inf,src)
		if m.type == MT_PLAYER and src.type == MT_PLAYER then
			local pt = m.player
			local ps = src.player
			if pt.waremem.killer then return false end
			ps.waremem.killer = true
		end
	end,
	fEnd = function()
		WARE_ForEachPlayer(function(p)
			p.pflags = $ & ~PF_FULLSTASIS
			p.mo.colorized = false
		end)
		for m in mobjs.iterate() do
			// MT_BIGTUMBLEWEED or MT_LITTLETUMBLEWEED
			if m.type == MT_BIGTUMBLEWEED or m.type == MT_LITTLETUMBLEWEED then P_RemoveMobj(m) end
		end
	end,
})

local function getmyscore(p)
	return WARE.mem.score[p.waremem.isred and 1 or 2]
end
local function getotherscore(p)
	return WARE.mem.score[p.waremem.isred and 2 or 1]
end
local function istie()
	return WARE.mem.score[1] == WARE.mem.score[2]
end
local function isredwinning()
	return WARE.mem.score[1] > WARE.mem.score[2]
end
local function amiwinning(p)
	return getmyscore(p) > getotherscore(p)
end
local function relocateBall(bal)
	local s = MAPPOS_AuxArena
	P_TeleportMove(bal, s.x*FRACUNIT,s.y*FRACUNIT,s.z*FRACUNIT)
	bal.momx = 0
	bal.momy = 32*FRACUNIT
	bal.momz = 32*FRACUNIT
	bal.tang = 0
end
WARE_AddMinigame("soccer", {
	boss = true,
	prompt = "Marque gols!",
	
	condition = function() return WARE.playercount > 1 end,
	spawnpoint = MAPPOS_AuxArena,
	
	music = "SOCCER",
	musicloop = true,
	skin = "sonic",
	
	timelimit = 60*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local s = MAPPOS_AuxArena
		local c = WARE.playercount
		local plys = shuffleTable(WARE_GetPlaying())
		local plys2 = {}
		for i = 1,#plys do
			// player, isRed
			local entry = {plys[i], false}
			if i <= c/2 then entry[2] = true end
			if i == #plys and #plys % 2 == 1 then // Odd one
				entry[2] = P_RandomChance(FRACUNIT/2)
			end
			table.insert(plys2, entry)
		end
		local px,py,pz = s.x*FRACUNIT,s.y*FRACUNIT,s.z*FRACUNIT
		local b = P_SpawnMobj(px, py, pz, MT_DUMMY)
		b.sprite = SPR_SOCC
		b.flags = MF_BOUNCE // Fuck you
		b.height = 40*FRACUNIT
		b.radius = 8*FRACUNIT
		b.scale = FRACUNIT*3/2
		b.kind = "ball"
		b.momy = 32*FRACUNIT
		b.momz = 32*FRACUNIT
		b.tang = 0
		for i = 1,#plys2 do
			local e = plys2[i]
			local p = e[1]
			local sep = 600*FRACUNIT * (e[2] and 1 or -1)
			P_TeleportMove(p.mo, px+sep, py, pz)
			p.waremem.isred = e[2]
			if e[2] then // red
				WARE_ForcePlayerSkin(p, "sonic", SKINCOLOR_RED)
				p.mo.angle = ANGLE_180
			else
				WARE_ForcePlayerSkin(p, "sonic", SKINCOLOR_BLUE)
				p.mo.angle = 0
			end
		end
		
		for i = -1,1,2 do
			local the = 1024*FRACUNIT*i
			local g = P_SpawnMobj(px+the, py, pz, MT_DUMMY)
			g.kind = "goal"
			g.isred = i == 1
			g.sprite = SPR_THOK
			g.radius = 12*FRACUNIT
			g.height = 28*FRACUNIT
			g.scale = FRACUNIT*2
			g.color = g.isred and SKINCOLOR_RED or SKINCOLOR_BLUE
			g.flags = 0
		end
		// red, blue
		mem.score = {0,0}
		mem.ball = b
		
		S_StartSound(nil, sfx_ronalo)
	end,
	fThink = function()
		local mem = WARE.mem
		
		WARE_ForEachPlayer(function(p)
			WARE_PlayerSetStatus(p, amiwinning(p), false)
		end)
		
		if abs(mem.score[1] - mem.score[2]) >= 3 then
			WARE_ForEachPlayer(function(p)
				WARE_PlayerSetStatus(p, amiwinning(p), true)
			end)
		end
	end,
	fHud = function(v,p,c)
		local mem = WARE.mem
		drawStringMkII(v,140*FRACUNIT,35*FRACUNIT,
			mem.score[1],FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=SKINCOLOR_RED,style=FS_FIXED}
		)
		drawStringMkII(v,160*FRACUNIT,35*FRACUNIT,
			"-",FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
		)
		drawStringMkII(v,180*FRACUNIT,35*FRACUNIT,
			mem.score[2],FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=SKINCOLOR_BLUE,style=FS_FIXED}
		)
		
		if mem.score[1]+mem.score[2] == 0 then
			drawStringMkII(v,160*FRACUNIT,140*FRACUNIT,
				"A equipe com maior pontuacao no final vencera!",FONT_CONSOLE2,
				V_SNAPTOBOTTOM,
				{valign="center",align="center",scale=FRACUNIT/2,color=SKINCOLOR_JET,style=FS_FIXED}
			)
			drawStringMkII(v,160*FRACUNIT,148*FRACUNIT,
				"Em um empate, ambas equipes perdem!",FONT_CONSOLE2,
				V_SNAPTOBOTTOM,
				{valign="center",align="center",scale=FRACUNIT/2,color=SKINCOLOR_JET,style=FS_FIXED}
			)
			drawStringMkII(v,160*FRACUNIT,156*FRACUNIT,
				"Vitoria instantanea se voce marcar 3 gols seguidos!",FONT_CONSOLE2,
				V_SNAPTOBOTTOM,
				{valign="center",align="center",scale=FRACUNIT/2,color=SKINCOLOR_JET,style=FS_FIXED}
			)
		end
		
		
	end,
	hMobjThinker = function(m)
		if m.kind == "ball" then
			//m.friction = FRACUNIT-256
			if (m.eflags & MFE_JUSTHITFLOOR) and m.prevmomz ~= nil then
				--if m.prevmomz == 0 then print("bruh") end
				m.momz = -m.prevmomz/2
				if abs(m.prevmomz) < FRACUNIT then m.momz = 0 end
			end
			if P_IsObjectOnGround(m) and m.momx == 0 and m.momy == 0 then
				m.momz = 4*FRACUNIT
			end
			if m.tang > 0 then m.tang = $-1 end
			m.prevmomz = m.momz
		elseif m.kind == "goal" then
			--m.momx = leveltime%2 and 5*FRACUNIT or -5*FRACUNIT
			searchBlockmap("objects", function(_, fn)
				if fn.type == MT_DUMMY and fn.kind == "ball" and R_PointToDist2(m.x,m.y,fn.x,fn.y) < FRACUNIT*32 then
					relocateBall(fn)
					WARE.mem.score[m.isred and 2 or 1] = $+1
					local p = fn.lasthit
					if p ~= nil then
						local pcol = p.waremem.isred and "\133" or "\132"
						local tgt = m.isred and "\132Azul" or "\133Vermelha"
						local expr = p.waremem.isred == m.isred and ". Oops!" or "!"
						print(pcol..p.name.."\128 marcou para a equipe "..tgt.."\128"..expr)
						S_StartSound(nil, sfx_hahaha)
					end
				end
			end, m)
		end
	end,
	hMobjMoveBlocked = function(m)
		if m.kind == "ball" then
			m.tang = 8
			m.momx = FixedMul($, FRACUNIT*3/2)
			m.momy = FixedMul($, FRACUNIT*3/2)
		end
	end,
	fCollide = function(m,n)
		if collZCheck(m,n) and m.type == MT_DUMMY and m.kind == "ball" and m.tang == 0 then
			if n.player and n.player.valid then
				m.lasthit = n.player
				local bump = FRACUNIT*6/5
				m.momx = FixedMul(n.momx, bump)
				m.momy = FixedMul(n.momy, bump)
				m.momz = FixedMul(n.momz+3*FRACUNIT, bump)
			end
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})




local pmax = 7
local platzone = {_RECURSIVEHIDE = true}
// the arena is 2048 squared
// radius is 1024
// each platform is 128

for x = -pmax,pmax do if not platzone[x] then platzone[x] = {} end
for y = -pmax,pmax do
	platzone[x][y] = 0
end
end
// 0: empty
// <0: taxicab checks
// >0: platforms

local function lookFor(hot, n)
	--print("asked to find "..n)
	local r = {}
	for x = -pmax,pmax do
		--print( table.concat(hot[x], ",", -15, 15) )
	for y = -pmax,pmax do
		if hot[x][y] == n then
			r[#r+1] = {x=x,y=y}
		end
	end
	end
	return r
end
local bigpos = {
	{0,1},
	{0,-1},
	{1,0},
	{-1,0},
}
local function taxicabcheck(origpz, x, y, depth)
	// Performs an unoptimized check expanding from x,y and seeing how far can we fucking go
	// If the largest available distance is equal to depth, immediately returns true
	// Otherwise returns false because no space lmao
	// depth 1 *would* return true since we just set origin
	// depth 2 will return true if there is at least one empty neighbor cell
	// depth 3 will return true if there are neighbors in neighbor cells, and so on
	
	if abs(x) > pmax or abs(y) > pmax then return false end // OOB, ignore
	if depth <= 1 then error("Lmao no.",2) end
	local level = -1
	local pz = deepcopy(origpz)
	if pz[x][y] > 0 then return false end // Ow, we can't do anything here we're in a FUCKING WALL
	pz[x][y] = -1 // yes we have a distance of 1 from literal origin fuck you
	while abs(level) < depth do
		local m = lookFor(pz,level)
		if #m == 0 then return false end // Blocked!!! NO MORE SPACE WE ARE DOOMED
		for i = 1,#m do
			local e = m[i]
			for iii = 1,4 do local bp = bigpos[iii];local xx,yy = bp[1],bp[2]
				local rx,ry = e.x+xx,e.y+yy // newest is highest
				if abs(rx) > pmax or abs(ry) > pmax then continue end // OOB, ignore
				local n = pz[rx][ry]
				if n == 0 // Empty
				or (n > 0 and n < -level) // This platform wouldn't be there by then
				then pz[rx][ry] = level-1 end
			end
		end
		level = $-1
	end
	// loop ended proper, therefore we have space to move afterwards
	return true
end

local function smol2Kool(x,y)
	if x == nil then error("smol2Kool says something is wrong",3) end
	local rx = (MAPPOS_Sky.x + 128*x)*FRACUNIT
	local ry = (MAPPOS_Sky.y + 128*y)*FRACUNIT
	return rx,ry
end

local shiftdown = 66*FRACUNIT
local function newplat(x,y)
	local s = MAPPOS_Sky
	local rx,ry = smol2Kool(x,y)
	local b = P_SpawnMobj(rx,ry,s.z*FRACUNIT-shiftdown, MT_DUMMY)
	b.flags = MF_NOGRAVITY|MF_SOLID
	--b.flags2 = $|MF2_STANDONME
	b.momx = 1
	b.height = 64*FRACUNIT
	b.radius = 64*FRACUNIT
	b.ptx = x
	b.pty = y
	b.kind = "hitbox"
	return b
end

local function addTo(array, plat)
	array[#array+1] = {p=plat, x=plat.ptx, y=plat.pty}
end

WARE_AddMinigame("pressure", {
	boss = true,
	prompt = "Nao caia!",
	
	spawnpoint = MAPPOS_Sky,
	
	music = "WAMFR2",
	musicloop = true,
	skin = "sonic",
	skynum = 1051,
	
	timelimit = 80*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.plats = deepcopy(platzone)
		mem.plats[0][0] = true
		mem.platarray = {}
		local b = newplat(0,0)
		addTo(mem.platarray, b)
		mem.when = TICRATE*2
		mem.whensep = TICRATE
		mem.maxplats = 7
		mem.sofar = 0
	end,
	fThink = function()
		local mem = WARE.mem
		if WARE.scaledtime > mem.when then
			mem.sofar = $+1
			//mem.whensep = max(2, TICRATE-mem.sofar/4)
			mem.whensep = max(8, TICRATE-(WARE.scaledtime/TICRATE/4))
			mem.when = $+mem.whensep
			// sfx_appear
			// Remove excess platforms now
			for i = #mem.platarray,1,-1 do
				local p = mem.platarray[i]
				local excess = #mem.platarray - mem.maxplats
				if i <= excess then
					table.remove(mem.platarray, i)
					mem.plats[p.x][p.y] = 0
					p.p.fall = true
				else
					local n = i - max(0,excess)
					mem.plats[p.x][p.y] = n
					p.p.myn = n
				end
			end
			
			// Spawn a new platform?
			local one = mem.platarray[#mem.platarray]
			
			local r = {}
			for iii = 1,4 do local bp = bigpos[iii];local xx,yy = bp[1],bp[2]
				local rs = taxicabcheck(mem.plats, one.x+xx, one.y+yy, mem.maxplats)
				if rs then r[#r+1] = {x=one.x+xx,y=one.y+yy} end
			end
			if #r == 0 then error("This is bad (NO SPACE???).") end
			local res = r[P_RandomRange(1,#r)]
			local b = newplat(res.x,res.y)
			addTo(mem.platarray, b)
			S_StartSound(b, sfx_appear)
		end
		WARE_ForEachPlayer(function(p)
			WARE_PlayerSetStatus(p, p.mo.z > 0, false)
			if p.mo.z < -384*FRACUNIT then P_DamageMobj(p.mo, nil, nil, 666, DMG_PIT) end
			if WARE.scaledtime < TICRATE then
				local m = p.mo
				m.momx,m.momy,m.momz = 0,0,0
			end
		end)
	end,
	hHurtMsg = function(p,i,s)
		print(p.name.." entrou na troposfera como uma bola de fogo.")
		return true
	end,
	hMobjThinker = function(m)
		local mem = WARE.mem
		if m.type == MT_DUMMY and m.kind == "hitbox" then
			if m.z < -384*FRACUNIT then P_RemoveMobj(m);return end
			if m.dcolor == nil then m.dcolor = vWrapSuper(mem.sofar,SKINCOLOR_CARBON,SKINCOLOR_BLACK) end
			m.color = m.dcolor
			if m.myn == nil then
				m.color = SKINCOLOR_GREEN
			else
				if m.myn <= 2 then m.color = SKINCOLOR_CRIMSON end
			end
			if m.sx == nil then
				m.sx,m.sy,m.sz = m.x,m.y,m.z
			end
			m.momx = leveltime%2 and 1 or -1
			m.momy,m.momz = 0,0
			if m.fall then
				m.momz = -16*FRACUNIT
				m.color = SKINCOLOR_RED
			else
				P_TeleportMove(m, m.sx,m.sy,m.sz)
			end
			if not m.vis then
				m.vis = {}
				for i = 1,6 do
					local n = P_SpawnMobj(m.x, m.y, m.z, MT_DUMMY)
					n.sprite = SPR_MWAL
					n.frame = B|FF_PAPERSPRITE
					m.vis[i] = n
					n.color = m.color
					n.pact = m
					n.kind = "vis"
				end
			end
			for i = 1,6 do
				local n = m.vis[i]
				if i <= 4 then
					n.angle = ANGLE_90*i
					local rx,ry = cSpd(n.angle+ANGLE_90,63*FRACUNIT)
					P_TeleportMove(n, m.x+rx, m.y+ry, m.z)
				else
					n.angle = (ANGLE_90*(i-5))
					n.frame = B|FF_PAPERSPRITE
					P_TeleportMove(n, m.x, m.y, m.z)
				end
			end
		elseif m.kind == "vis" then
			if not (m.pact and m.pact.valid) then P_RemoveMobj(m);return end
			m.color = m.pact.color
		end
	end,
	fHud = function(v,p)
		if WARE.scaledtime < TICRATE then
			v.drawString(160,100,"(congelado)", V_SKYMAP, "center")
		end
	end,
	fCollide = function(m,n)
		if m.type == n.type then return false end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

rawset(_G, "MODULMINIB", true)